<script>
import TopContributionsByValue from "./TopContributionsByValue";

export default {
  name: "TopContributions",
  components: {
    TopContributionsByValue
  },
  data () {
    return {
      showDate: true,
      showComments: false
    };
  },
  computed: {
    shownData () {
      return this.showDate
        ? this.$store.getters.recentContributions
        : this.$store.getters.mostCommentedContributions;
    }
  },
  created () {
    this.$store.dispatch("recentContributions");
    this.$store.dispatch("mostCommentedContributions");
  },
  methods: {
    switchDateComments () {
      this.showDate ^= 1;
      this.showComments ^= 1;
    }
  }
};
</script>

<template>
  <div class="TopContributions">
    <div class="switcher">
      <div
        :class="{underline: showDate}"
        role="button"
        tabindex="0"
        @click="switchDateComments"
        @keyup.enter="switchDateComments"
      >
        {{ $t("components.TopContributions.displayToggles.date") }}
      </div>

      <div
        :class="{underline: showComments}"
        role="button"
        tabindex="0"
        @click="switchDateComments"
        @keyup.enter="switchDateComments"
      >
        {{ $t("components.TopContributions.displayToggles.comments") }}
      </div>
    </div>

    <TopContributionsByValue
      :dataToShow="shownData"
    />
  </div>
</template>

<style lang="scss">
@import "../../../scss/_global.scss";

div.TopContributions {
  display: flex;
  flex-direction: column;
  height: 100%;
  overflow: hidden;

  div.switcher {
    display: flex;
    flex-direction: row;
    justify-content: center;
    text-align: center;

    div.underline {
      margin-left: 0.75rem;
      margin-right: 0.75rem;
      margin-top: 1rem;
      margin-bottom: 1rem;
      cursor: pointer;
      color: $color_primary_1;
      @extend %fontdefinition_subline;
      text-decoration: underline;
    }

    div {
      margin-left: 0.75rem;
      margin-right: 0.75rem;
      margin-top: 1rem;
      margin-bottom: 1rem;
      cursor: pointer;
      color: $color_primary_1;
      @extend %fontdefinition_subline;
      font-weight: normal;
    }
  }

  & > section {
    h3 {
      @extend %fontdefinition_subline;
    }
  }

  hr {
    width: 75%;
    border-top: solid 1px $color_primary_1;
    margin: 15px auto;
  }

  table {
    td, th {
      border: solid 1px $color_secondary_3;
      padding: 0 5px;
      text-align: center
    }

    th:nth-child(1), td:nth-child(1) {
      text-align: left;
    }
  }
  div.a.switcher {
    text-decoration-line: underline;
  }
}
</style>
